=== debian/changelog ===
vkfft (1.2.17+ds1-1) unstable; urgency=medium

  * New upstream version 1.2.17+ds1
  * d/control: Added Debian Science Maintainers
    <debian-science-maintainers@lists.alioth.debian.org>

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 06 Jan 2022 18:03:24 +0100

vkfft (1.2.12+ds1-2) unstable; urgency=medium

  * Source-only upload for migration to testing, no changes.

 -- Roland Mas <lolando@debian.org>  Fri, 05 Nov 2021 15:09:58 +0100

vkfft (1.2.12+ds1-1) unstable; urgency=medium

  [ Picca Frédéric-Emmanuel ]
  * Initial release (closes: #996396).

  [ Roland Mas ]
  * Packaging fixes

 -- Roland Mas <lolando@debian.org>  Wed, 13 Oct 2021 19:25:22 +0200
