=== debian/changelog ===
vkfft (1.2.26+ds1-1) unstable; urgency=medium

  * New upstream version 1.2.26+ds1

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 18 Sep 2022 13:11:01 +0200
