=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  glslang-dev,
  libvulkan-dev,
  python3,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/DTolm/VkFFT
 Vcs-Browser: https://salsa.debian.org/science-team/vkfft
