=== debian/watch ===
version=4
opts="repacksuffix=+ds1,\
 dversionmangle=s/\+ds\d+//,\
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/DTolm/VkFFT/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
