=== debian/changelog ===
vkfft (1.3.4+ds2-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 15 Jul 2024 15:35:41 +0200

vkfft (1.3.4+ds2-1) unstable; urgency=medium

  * New upstream version 1.3.4+ds2

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 16 Feb 2024 14:38:24 +0100

vkfft (1.3.1+ds2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libvkfft-dev: Add Multi-Arch: foreign.

  [ Picca Frédéric-Emmanuel ]
  * exclude the metal-cpp files (not usefull on Linux)
  * New upstream version 1.3.1+ds2

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 20 Sep 2023 21:33:35 +0200
