=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  glslang-dev,
  libvulkan-dev,
  python3,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/DTolm/VkFFT
 Vcs-Browser: https://salsa.debian.org/science-team/vkfft
@@ -23,6 +23,7 @@
 Architecture: all
 Depends:
  ${misc:Depends},
+Multi-Arch: foreign
 Description: Vulkan/CUDA/HIP/OpenCL Fast Fourier Transform library
  VkFFT is an efficient GPU-accelerated multidimensional Fast Fourier
  Transform library for Vulkan/CUDA/HIP/OpenCL projects. VkFFT aims to
